/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_CONCURRENCY_MODEL_H
#define _NEST_CONCURRENCY_MODEL_H

#include "nest_client.h"

class nestConcurrencyModel {

  public:

    nestConcurrencyModel( int id );
    virtual ~nestConcurrencyModel( ) { };

    virtual NestReplyStatus addTask( nestClient *client ) = 0;

    virtual NestReplyStatus makeProgress( fd_set *r_ready,
										  fd_set *w_ready ) =0;

    virtual int getMaxfd( ) = 0;

    virtual int getId();

    virtual NestReplyStatus abortTask( nestClient *client );

    virtual NestReplyStatus pauseTask( nestClient *client );

    virtual NestReplyStatus updateTaskInfo( nestClient *client );

    virtual NestReplyStatus sigChild( int,
									  siginfo_t *,
									  void *,
									  fd_set *ready );

    virtual NestReplyStatus debugLevel( int new_level );

    virtual char* toString( ) = 0;

  protected:
    int maxfd;
    int id;
    int concurrency_size;
};

#include "nest_common.h"

#endif
