/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NEST_FILECACHE_MODEL_MGR_H
#define NEST_FILECACHE_MODEL_MGR_H

#include <stdio.h>
#include <assert.h>
#include <sys/time.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#include "nest_common.h"
#include "nest_storage_manager.h"
#include "nest_filetransfer.h"
#include "nest_filecache_model.h"

#define DEFAULT_CACHE_SIZE       500
#define DEFAULT_CACHE_THRESHOLD  10 
#define DEFAULT_GROWTH_SIZE      5

enum {
    NEST_CACHE_CLOCK,
    NEST_CACHE_LRU
};

class nestFilecacheModelManager {

public:

    nestFilecacheModelManager( int type );

    int taskDone(
            const char *file, 
            nestFiletransfer *transfer, 
            int concurrency_model,
            int current_tasks );

    bool contains( const char *file );

    bool insert( const char *file, nestFiletransfer *transfer, long filesize );
    
    ssize_t writeAd( nestProtocol *ad );

private:

    nestFilecacheModel *model;

    int           cachetype;
    int           growth_size;
    unsigned long cachehit_guesses;
    unsigned long cachemiss_guesses;
    unsigned long false_hits;
    unsigned long correct_misses;
    unsigned long correct_hits;
    unsigned long false_misses;
    float cache_threshold;
    float cache_initial_size;
    nestProtocol *cacheguesslog;
    nestProtocol *cachesizelog;

};

#endif
