/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef _NEST_WORKER_POOL_H
#define _NEST_WORKER_POOL_H

#include "nest_common.h"
#include "nest_worker.h"
#include "nest_protocol_manager.h"
#include "nest_speak.i.h"

enum { WORKER_BUSY, WORKER_IDLE, WORKER_DEAD };

class 
nestWorkerPool {

  public:

    nestWorkerPool( int quantity,
					fd_set * watchfds, 
					int( * ) (int ),
					nestProtocolManager *pm );

    int createWorkers( int quantity, fd_set * watchfds );

    nestWorker* getIdleWorker( );

    int addWorker( pid_t pid, int stream, int id, fd_set *watchfds );

    int removeWorker ( pid_t pid, fd_set *watchfds, fd_set *readyfds );

    nestWorker* getWorker( pid_t pid );

    nestWorker* getWorkerFromID( int id );

    nestWorker* canReceiveMessage( fd_set *readyfds );

    int getMaxfds( );

    ssize_t size( );

    void debugLevel( long level );

    static bool SendWorkerMessage( NestConnection con, int id, int client_id,
            int client_socket, int status, nestFiletransfer *transfer );

    static NestReplyStatus ReceiveWorkerMessage( NestConnection con,
            int &client_id, int &client_socket, struct IO_Measurement * ); 
    

private:

    list< nestWorker* > workers;
    int maxfd;
    int (*worker_loop) (int);    
    int worker_id;
	nestProtocolManager *protocol_manager;
};    



#endif
