/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/

#ifndef NETWORK_LIMIT_H
#define NETWORK_LIMIT_H

#include <pthread.h>

class NetworkLimit {
public:
    NetworkLimit();

           // Set network bandwidth, measured in bytes per second.
    // Zero means unlimited.
    // Default bandwidth is zero.
    void setBandwidth( unsigned long bytes );

    // Set measurement interval in microseconds.
    // Default interval is 1/4 second.
    void setInterval( unsigned long micros );

    // Declare an intent to consume this many bytes.
    // The caller may be delayed until bandwidth is available.
    void consumeBandwidth( unsigned long bytes );

    // Control producedure run by the contained thread.
    // Don't call this yourself.
    void run();

private:
    unsigned long bandwidth;
    unsigned long available;
    unsigned long interval;

    pthread_mutex_t mutex;
    pthread_cond_t cond;
};

#endif
