/***************************Copyright-DO-NOT-REMOVE-THIS-LINE**
  *
  * Condor Software Copyright Notice
  * Copyright (C) 1990-2005, Condor Team, Computer Sciences Department,
  * University of Wisconsin-Madison, WI.
  *
  * This source code is covered by the Condor Public License, which can
  * be found in the accompanying LICENSE.TXT file, or online at
  * www.condorproject.org.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  * AND THE UNIVERSITY OF WISCONSIN-MADISON "AS IS" AND ANY EXPRESS OR
  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
  * WARRANTIES OF MERCHANTABILITY, OF SATISFACTORY QUALITY, AND FITNESS
  * FOR A PARTICULAR PURPOSE OR USE ARE DISCLAIMED. THE COPYRIGHT
  * HOLDERS AND CONTRIBUTORS AND THE UNIVERSITY OF WISCONSIN-MADISON
  * MAKE NO MAKE NO REPRESENTATION THAT THE SOFTWARE, MODIFICATIONS,
  * ENHANCEMENTS OR DERIVATIVE WORKS THEREOF, WILL NOT INFRINGE ANY
  * PATENT, COPYRIGHT, TRADEMARK, TRADE SECRET OR OTHER PROPRIETARY
  * RIGHT.
  *
  ****************************Copyright-DO-NOT-REMOVE-THIS-LINE**/
#ifndef __NEST_NFS_UTIL_H
#define __NEST_NFS_UTIL_H

#include <assert.h>
#include "nfs_prot.h"
#include "nfs_mount.h"
#include "nest_error.h"

#include "rpcudp_lib.h"

char *nfs_error(   enum nfsstat nfssstat );
char *nfs_request( int req );
char *mount_request( int req );
void nfs_dump_request( struct svc_req *rqstp, char *req, bool suppress_ip = true );

int   nfsFilehandleToInt( void *nfs_fh );
int   filehandleToInt(    NestFilehandle *handle );
void *filehandleCopy(     void *nfs_fh, NestFilehandle *handle );
void *filehandleCopy2(    NestFilehandle *handle, void *nfs_fh );

NestReplyStatus NFSStatusToNestStatus( enum nfsstat status );
enum nfsstat NestStatusToNFSStatus( NestReplyStatus status ); 

#endif
